/*
 * Unique Schlüssel für JPA Entität
 */
package de.ivu.elect.business.email.entity;
import java.util.function.Function;
import java.util.ArrayList;
import java.util.stream.Collectors;

@javax.enterprise.inject.Vetoed
public class EmailVorlageUK
implements de.ivu.elect.jee.entity.tk.EntityUK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

    protected final java.lang.String bezeichnung;

    public java.lang.String getBezeichnung(){
      return bezeichnung;
    }

  protected final de.ivu.elect.business.wahl.entity.WahlterminUK wahlterminUK;

    public de.ivu.elect.business.wahl.entity.WahlterminUK getWahlterminUK(){
      return wahlterminUK;
    }

  public EmailVorlageUK(
java.lang.String bezeichnung
,   de.ivu.elect.business.wahl.entity.WahlterminUK wahlterminUK
  ) {
    super();


      this.bezeichnung = bezeichnung;
        this.wahlterminUK = wahlterminUK;
    }

  @Override
  public int hashCode() {
        int result = 1;
    
    
                    result = result + ((bezeichnung == null) ? 0 : bezeichnung.hashCode());
        
                    result = result + ((wahlterminUK == null) ? 0 : wahlterminUK.hashCode());
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    
    if (getClass() != obj.getClass()) {
      return false;
    }

            EmailVorlageUK other = (EmailVorlageUK) obj;

                if (bezeichnung == null) {
          if (other.bezeichnung != null) {
            return false;
          }
        } else if (!bezeichnung.equals(other.bezeichnung)) {
          return false;
        }
        
                if (wahlterminUK == null) {
          if (other.wahlterminUK != null) {
            return false;
          }
        } else if (!wahlterminUK.equals(other.wahlterminUK)) {
          return false;
        }
            
    return true;
  }

  @Override
  public String getEntityMessageKey() {
    return EmailVorlageConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    result.addAll(wahlterminUK.getAllEntityFieldValues());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(EmailVorlageConstants.MESSAGE_KEY_ENTITY_EINZAHL, EmailVorlageConstants.MESSAGE_KEY_BEZEICHNUNG_EINZAHL, bezeichnung));
        
        return result;
      }
  
    @Override
  public String toString() {
    return "EmailVorlageUK[" + toStringParameter() + "]";
  }

            protected String toStringParameter() {
              String result = ""

                                                        +"bezeichnung="+bezeichnung
                                        +", "                +"wahlterminUK="+wahlterminUK
                        ;
                          return result;
            
            }




          public String allUKFields() {
    return String.join(", ", getAllUKFieldValues().stream()
         .map(object -> (object != null ? object.toString() : null))
         .collect(Collectors.toList()));
    }

   protected ArrayList<Object> getAllUKFieldValues() {
              ArrayList<Object> list = new ArrayList<>();
              list.add(bezeichnung);
     return list;
   }

            public static <E extends EmailVorlage> java.util.Map<EmailVorlageUK, E> mappeEmailVorlageNachUK(java.util.Collection<E> entities) {

                return entities.stream().collect(java.util.stream.Collectors.toMap(EmailVorlage::getEmailVorlageUK, Function.<E>identity(), (u,v)->v));
             }


                public static Function<EmailVorlage, EmailVorlageUK> getEmailVorlageToUKFunction() {
                return EmailVorlage::getEmailVorlageUK;
                }

}
